/*
 * Header file for foundation from NeXT 
 * internal classes description -- useful for debugging in gdb
 */
 
#ifndef    __HiddenClasses_H_
#define    __HiddenClasses_H_

#include <Foundation/NSArray.h>
#include <Foundation/NSDictionary.h>
#include <Foundation/NSString.h>
#include <Foundation/NSValue.h>

@interface NSConcreteArray : NSArray
{
	int		_countAndRefCount;
	id		*_items;
}
@end

@interface NSConcreteMutableArray : NSMutableArray
{
	int		_countAndRefCount;
	id		*_items;
	int		_maxItems;
}
@end


@interface NSConcreteDictionary : NSDictionary
{
	void		*table;
}
@end

@interface NSConcreteMutableDictionary : NSMutableDictionary
{
	void		*table;
}
@end

@interface NSInlineCString : NSString
{
	struct		{
		int			refs:8;
		int			numBytes:24;
	} _flags;
	char		bytes[1];
}
@end

@interface NSConcreteMutableString : NSMutableString
{
	struct		{
		int			refs:8;
		BOOL		contentsIsMine:1;
		BOOL		contentsIsCString:1;
		int			dummy:6;		
		int			capacity:16;
	} _flags;
	id			contents;
}
@end

@interface NSCString : NSSimpleCString
{
	struct		{
		int			refs:8;
		BOOL		freeWhenDone:1;
		int			dummy:6;		
		BOOL		canWriteIntoBuffer:1;
		int			capacity:16;
	} _flags;
}
@end

@interface NSCStringWithGap : NSCString
{
	int		gapBegin;
	int		gapEnd;
}
@end

@interface NSConcreteValue : NSValue
{
	char*	objCSizeAndType;
	union {
		int		integer;
		id		object;
		void*	pointer;
	} value;
}
@end

@interface NSRefCountingNumber : NSNumber
{
	short	refs;
}
@end

@interface NSintNumber : NSRefCountingNumber
{
	int		value;
}
@end

@interface NSunsignedIntNumber : NSRefCountingNumber
{
	unsigned		value;
}
@end

#endif /* __HiddenClasses_H_ */
